/*
* AllBinary Open License Version 1
* Copyright (c) 2011 AllBinary
* 
* By agreeing to this license you and any business entity you represent are
* legally bound to the AllBinary Open License Version 1 legal agreement.
* 
* You may obtain the AllBinary Open License Version 1 legal agreement from
* AllBinary or the root directory of AllBinary's AllBinary Platform repository.
* 
* Created By: Travis Berthelot
* 
*/
package allbinary.data.tables.log;

import abcs.logic.communication.log.LogFactory;
import abcs.logic.communication.log.LogUtil;

public class LogTableEntityFactory
{
    private static final LogTableEntityFactory instance =
            new LogTableEntityFactory();

    /**
     * @return the instance
     */
    public static LogTableEntityFactory getInstance() {
        return instance;
    }

   //private final String CLASSNAME = "allbinary.data.tables.LogTableEntity";
   
   private LogTableEntityFactory()
   {
   }
   
   public LogTableEntity getLogTableEntityInstance() //throws LicensingException
   {
      try
      {
         //Object object = AbeFactory.getInstance(CLASSNAME);
         //return (LogTableEntityInterface) InterfaceCastProxy.newInstance(object);
         return new allbinary.data.tables.log.LogTableEntity();
      }
      /*
      catch(LicensingException e)
      {
         String error = "Failed to get instance";
         if(abcs.logic.communication.log.config.type.LogConfigTypes.LOGGING.contains(abcs.logic.communication.log.config.type.LogConfigType.ENTITYFACTORYERROR))
         {
            LogUtil.put(error,"LogTableEntityFactory","getInstance()",e);
         }
         throw e;
      }
       */
      catch(Exception e)
      {
         String error = "Failed get Instance";
         if(abcs.logic.communication.log.config.type.LogConfigTypes.LOGGING.contains(abcs.logic.communication.log.config.type.LogConfigType.ENTITYFACTORYERROR))
         {
            LogUtil.put(LogFactory.getInstance(error,"LogTableEntityFactory","getInstance()",e));
         }
         return null;
      }
   }
   
}
