/*
* AllBinary Open License Version 1
* Copyright (c) 2011 AllBinary
* 
* By agreeing to this license you and any business entity you represent are
* legally bound to the AllBinary Open License Version 1 legal agreement.
* 
* You may obtain the AllBinary Open License Version 1 legal agreement from
* AllBinary or the root directory of AllBinary's AllBinary Platform repository.
* 
* Created By: Travis Berthelot
* 
*/
package allbinary.input.automation.module.generic.configuration.profile.actions.script.condition;

import abcs.logic.communication.log.Log;
import abcs.logic.communication.log.LogUtil;

/**
 *
 * @author  USER
 */
public class AlwaysActionScriptConditionJPanel
    extends javax.swing.JPanel
{
    private AlwaysActionScriptConditionInterface alwaysActionScriptConditionInterface;
    
    /** Creates new form ColorAtActionJPanel */
    public AlwaysActionScriptConditionJPanel(
        AlwaysActionScriptConditionInterface alwaysActionScriptConditionInterface)
    {
        LogUtil.put(new Log("Start", this, "Constructor"));
        
        initComponents();
        
        this.alwaysActionScriptConditionInterface = alwaysActionScriptConditionInterface;
        
        this.set();
    }
    
    private void set()
    {
        if(this.alwaysActionScriptConditionInterface.isIsOn())
        {
            this.alwaysJComboBox.setSelectedIndex(0);
        }
        else
        {
            this.alwaysJComboBox.setSelectedIndex(1);
        }
        
        this.alwaysActionScriptConditionInterface.log();
    }

    private void update()
    {
        if(this.alwaysJComboBox.getSelectedIndex() == 0)
        {
            this.alwaysActionScriptConditionInterface.setIsOn(true);
        }
        else
        {
            this.alwaysActionScriptConditionInterface.setIsOn(false);
        }

        this.alwaysActionScriptConditionInterface.log();
    }

    public javax.swing.JDialog getAlwaysActionJDialog()
    {
        return alwaysActionJDialog;
    }

    public void setAlwaysActionJDialog(javax.swing.JDialog alwaysActionJDialog)
    {
        this.alwaysActionJDialog = alwaysActionJDialog;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        alwaysActionJDialog = new javax.swing.JDialog();
        titleJLabel = new javax.swing.JLabel();
        okJButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        alwaysJComboBox = new javax.swing.JComboBox();
        alwaysActionJButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        alwaysActionJDialog.setMinimumSize(new java.awt.Dimension(250, 150));
        titleJLabel.setText("Always Condition Options");

        okJButton.setText("OK");
        okJButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                okJButtonActionPerformed(evt);
            }
        });

        jLabel2.setText("On:");

        alwaysJComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "true", "false" }));

        javax.swing.GroupLayout alwaysActionJDialogLayout = new javax.swing.GroupLayout(alwaysActionJDialog.getContentPane());
        alwaysActionJDialog.getContentPane().setLayout(alwaysActionJDialogLayout);
        alwaysActionJDialogLayout.setHorizontalGroup(
            alwaysActionJDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(alwaysActionJDialogLayout.createSequentialGroup()
                .addGroup(alwaysActionJDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(alwaysActionJDialogLayout.createSequentialGroup()
                        .addGap(47, 47, 47)
                        .addGroup(alwaysActionJDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, alwaysActionJDialogLayout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(alwaysJComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(titleJLabel)))
                    .addGroup(alwaysActionJDialogLayout.createSequentialGroup()
                        .addGap(79, 79, 79)
                        .addComponent(okJButton)))
                .addContainerGap(45, Short.MAX_VALUE))
        );
        alwaysActionJDialogLayout.setVerticalGroup(
            alwaysActionJDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(alwaysActionJDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(titleJLabel)
                .addGap(20, 20, 20)
                .addGroup(alwaysActionJDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(alwaysJComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addGap(15, 15, 15)
                .addComponent(okJButton)
                .addContainerGap())
        );

        setMinimumSize(new java.awt.Dimension(100, 0));
        alwaysActionJButton.setText("Edit");
        alwaysActionJButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                alwaysActionJButtonActionPerformed(evt);
            }
        });

        jLabel1.setText("Always:");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 33, Short.MAX_VALUE)
                .addComponent(alwaysActionJButton))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jLabel1)
                .addComponent(alwaysActionJButton))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void okJButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_okJButtonActionPerformed
    {//GEN-HEADEREND:event_okJButtonActionPerformed
// TODO add your handling code here:
        this.update();
        this.getAlwaysActionJDialog().setVisible(false);
    }//GEN-LAST:event_okJButtonActionPerformed
    
    private void alwaysActionJButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_alwaysActionJButtonActionPerformed
    {//GEN-HEADEREND:event_alwaysActionJButtonActionPerformed
// TODO add your handling code here:
        this.getAlwaysActionJDialog().setVisible(true);
    }//GEN-LAST:event_alwaysActionJButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton alwaysActionJButton;
    private javax.swing.JDialog alwaysActionJDialog;
    private javax.swing.JComboBox alwaysJComboBox;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JButton okJButton;
    private javax.swing.JLabel titleJLabel;
    // End of variables declaration//GEN-END:variables
    
}
