/*
* AllBinary Open License Version 1
* Copyright (c) 2011 AllBinary
* 
* By agreeing to this license you and any business entity you represent are
* legally bound to the AllBinary Open License Version 1 legal agreement.
* 
* You may obtain the AllBinary Open License Version 1 legal agreement from
* AllBinary or the root directory of AllBinary's AllBinary Platform repository.
* 
* Created By: Travis Berthelot
* 
*/
package allbinary.input.automation.module.generic.configuration.profile.actions.script.condition;

import abcs.logic.communication.log.Log;
import abcs.logic.communication.log.LogUtil;

/**
 *
 * @author  USER
 */
public class TimeIntervalActionScriptConditionJPanel
    extends javax.swing.JPanel
{
    private TimeIntervalActionScriptConditionInterface timeIntervalActionScriptConditionInterface;
    
    /** Creates new form ColorAtActionJPanel */
    public TimeIntervalActionScriptConditionJPanel(
        TimeIntervalActionScriptConditionInterface timeIntervalActionScriptConditionInterface)
    {
        LogUtil.put(new Log("Start", this, "Constructor"));
        
        initComponents();
        
        this.timeIntervalActionScriptConditionInterface = timeIntervalActionScriptConditionInterface;
        
        this.set();
    }
    
    private void set()
    {
        this.getTimeIntervalJTextField().setText(
            Integer.toString(this.timeIntervalActionScriptConditionInterface.getTimeHelper().getDelay()));
        
        this.timeIntervalActionScriptConditionInterface.log();
        
    }

    private void update()
    {
        this.timeIntervalActionScriptConditionInterface.getTimeHelper().setDelay(
            Integer.valueOf(this.getTimeIntervalJTextField().getText()));

        this.timeIntervalActionScriptConditionInterface.log();
    }

    public javax.swing.JTextField getTimeIntervalJTextField()
    {
        return timeIntervalJTextField;
    }

    public void setTimeIntervalJTextField(javax.swing.JTextField timeIntervalJTextField)
    {
        this.timeIntervalJTextField = timeIntervalJTextField;
    }

    public javax.swing.JDialog getTimeIntervalActionJDialog()
    {
        return timeIntervalActionJDialog;
    }

    public void setTimeIntervalActionJDialog(javax.swing.JDialog timeIntervalActionJDialog)
    {
        this.timeIntervalActionJDialog = timeIntervalActionJDialog;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        timeIntervalActionJDialog = new javax.swing.JDialog();
        titleJLabel = new javax.swing.JLabel();
        okJButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        timeIntervalJTextField = new javax.swing.JTextField();
        timeIntervalActionJButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        timeIntervalActionJDialog.setMinimumSize(new java.awt.Dimension(250, 150));
        titleJLabel.setText("Time Interval Condition Options");

        okJButton.setText("OK");
        okJButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                okJButtonActionPerformed(evt);
            }
        });

        jLabel2.setText("Time (ms):");

        javax.swing.GroupLayout timeIntervalActionJDialogLayout = new javax.swing.GroupLayout(timeIntervalActionJDialog.getContentPane());
        timeIntervalActionJDialog.getContentPane().setLayout(timeIntervalActionJDialogLayout);
        timeIntervalActionJDialogLayout.setHorizontalGroup(
            timeIntervalActionJDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(timeIntervalActionJDialogLayout.createSequentialGroup()
                .addGroup(timeIntervalActionJDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, timeIntervalActionJDialogLayout.createSequentialGroup()
                        .addGap(82, 82, 82)
                        .addComponent(okJButton))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, timeIntervalActionJDialogLayout.createSequentialGroup()
                        .addGap(32, 32, 32)
                        .addGroup(timeIntervalActionJDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(timeIntervalActionJDialogLayout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addGap(16, 16, 16)
                                .addComponent(timeIntervalJTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 85, Short.MAX_VALUE))
                            .addComponent(titleJLabel))))
                .addContainerGap(36, Short.MAX_VALUE))
        );
        timeIntervalActionJDialogLayout.setVerticalGroup(
            timeIntervalActionJDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(timeIntervalActionJDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(titleJLabel)
                .addGap(20, 20, 20)
                .addGroup(timeIntervalActionJDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(timeIntervalJTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(15, 15, 15)
                .addComponent(okJButton)
                .addContainerGap())
        );

        setMinimumSize(new java.awt.Dimension(100, 0));
        timeIntervalActionJButton.setText("Edit");
        timeIntervalActionJButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                timeIntervalActionJButtonActionPerformed(evt);
            }
        });

        jLabel1.setText("Time Interval:");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(timeIntervalActionJButton))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jLabel1)
                .addComponent(timeIntervalActionJButton))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void okJButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_okJButtonActionPerformed
    {//GEN-HEADEREND:event_okJButtonActionPerformed
// TODO add your handling code here:
        this.update();
        this.getTimeIntervalActionJDialog().setVisible(false);
    }//GEN-LAST:event_okJButtonActionPerformed
    
    private void timeIntervalActionJButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_timeIntervalActionJButtonActionPerformed
    {//GEN-HEADEREND:event_timeIntervalActionJButtonActionPerformed
// TODO add your handling code here:
        this.getTimeIntervalActionJDialog().setVisible(true);
    }//GEN-LAST:event_timeIntervalActionJButtonActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JButton okJButton;
    private javax.swing.JButton timeIntervalActionJButton;
    private javax.swing.JDialog timeIntervalActionJDialog;
    private javax.swing.JTextField timeIntervalJTextField;
    private javax.swing.JLabel titleJLabel;
    // End of variables declaration//GEN-END:variables
    
}
