/*
* AllBinary Open License Version 1
* Copyright (c) 2011 AllBinary
* 
* By agreeing to this license you and any business entity you represent are
* legally bound to the AllBinary Open License Version 1 legal agreement.
* 
* You may obtain the AllBinary Open License Version 1 legal agreement from
* AllBinary or the root directory of AllBinary's AllBinary Platform repository.
* 
* Created By: Travis Berthelot
* 
*/
package allbinary.image.gui;

import abcs.logic.communication.log.Log;
import abcs.logic.communication.log.LogUtil;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

public class ImageJPanel extends javax.swing.JPanel
{
    private boolean isDrawn = false;
    private BufferedImage bufferedImage;
    
    public ImageJPanel(BufferedImage bufferedImage)
    {
        initComponents();
        
        this.bufferedImage = bufferedImage;
        this.setSize(this.bufferedImage.getWidth(null), 
            this.bufferedImage.getHeight(null));
    }
    
    public void paint(Graphics graphics)
    {
        if(!isDrawn)
        {
        LogUtil.put(new Log("Painting", this, "paint"));

        graphics.drawImage(bufferedImage, 0, 0,
            this.bufferedImage.getWidth(null), 
            this.bufferedImage.getHeight(null), null);
        isDrawn = true;
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    
}
