/*
* AllBinary Open License Version 1
* Copyright (c) 2011 AllBinary
* 
* By agreeing to this license you and any business entity you represent are
* legally bound to the AllBinary Open License Version 1 legal agreement.
* 
* You may obtain the AllBinary Open License Version 1 legal agreement from
* AllBinary or the root directory of AllBinary's AllBinary Platform repository.
* 
* Created By: Travis Berthelot
* 
*/
package allbinary.game.layer.weapon;

import org.allbinary.physics.movement.Movement;

import allbinary.animation.Animation;
import allbinary.graphics.Rectangle;
import allbinary.view.ViewPosition;

public class SimpleWeaponLayer extends WeaponLayer
{
    public SimpleWeaponLayer(Movement movement,
            Animation animationInterface,
            Rectangle rectangle, ViewPosition viewPosition)
            throws Exception
    {
        super(movement, animationInterface, rectangle, viewPosition);
        
        this.setCollidableInferface(new CollidableWeaponBehavior(this, true));
    }

    public SimpleWeaponLayer(Movement movement,
            Animation animationInterface,
            Animation destroyedAnimationInterface,
            Rectangle rectangle, ViewPosition viewPosition)
            throws Exception
    {
        super(movement, animationInterface, destroyedAnimationInterface, rectangle, viewPosition);
        
        this.setCollidableInferface(new CollidableWeaponBehavior(this, true));
    }

    public SimpleWeaponLayer(Movement movement,
            Animation animationInterface,
            Animation destroyedAnimationInterface,
            Rectangle rectangle, ViewPosition viewPosition, String username, int actorSessionId, int multiPlayerType)
            throws Exception
    {
        super(movement, animationInterface, destroyedAnimationInterface, rectangle, viewPosition, username, actorSessionId, multiPlayerType);
        
        this.setCollidableInferface(new CollidableWeaponBehavior(this, true));
    }
}
