/*
 * AllBinary Open License Version 1
 * Copyright (c) 2011 AllBinary
 * 
 * By agreeing to this license you and any business entity you represent are
 * legally bound to the AllBinary Open License Version 1 legal agreement.
 * 
 * You may obtain the AllBinary Open License Version 1 legal agreement from
 * AllBinary or the root directory of AllBinary's AllBinary Platform repository.
 * 
 * Created By: Travis Berthelot
 * 
 */
package allbinary.animation;

import allbinary.game.configuration.GameConfigurationCentral;
import allbinary.math.AngleFactory;
import allbinary.math.AngleInfo;

public class RotationAnimationFactory implements
        AnimationInterfaceFactoryInterface,
        ProceduralAnimationInterfaceFactoryInterface
{
    private short totalAngle;
    private short angleIncrement;

    public RotationAnimationFactory()
    {
        this.totalAngle = AngleFactory.getInstance().TOTAL_ANGLE;

        this.angleIncrement = (short) (totalAngle / GameConfigurationCentral.getInstance().getGameControlFidelity());
    }

    public RotationAnimationFactory(short totalAngle, short angleIncrement)
    {
        this.totalAngle = totalAngle;
        this.angleIncrement = angleIncrement;
    }
    
    public Animation getInstance() throws Exception
    {
        return new NullRotationAnimation(
                AngleInfo.getInstance(this.angleIncrement), this.totalAngle);
    }

    public Animation getInstance(Animation animationInterface) throws Exception
    {
        return new NullRotationAnimation(
                AngleInfo.getInstance(this.angleIncrement), this.totalAngle);
    }
}